#include "GyverTimer.h"
#include <GyverPower.h>
#include "GyverButton.h"
#include <EEPROM.h>
//LEDS 4x2
#define led1 5
#define led2 6
#define led3 9
#define led4 10
//Inputs
#define pir 3
#define sens 8
#define sens_pwr 12
GButton sensor(sens);

int menu = 0;
int isAwake = 0;
int dimming;
String dimming_s;
String timing;
bool menu_true = true;
GTimer LedTime(MS);

void(* resetFunc) (void) = 0;                       //Reset function

void setup() {
  pinMode(led1, OUTPUT);
  pinMode(led2, OUTPUT);
  pinMode(led3, OUTPUT);
  pinMode(led4, OUTPUT);
   pinMode(13, OUTPUT);
   digitalWrite(13, LOW);
  pinMode(sens_pwr, OUTPUT);
  pinMode(pir, INPUT_PULLUP);
  pinMode(sens, INPUT_PULLUP);
  attachInterrupt(1, isr, FALLING);
  power.setSleepMode(POWERDOWN_SLEEP);

  //Sensor button settings
  sensor.setDebounce(100);
  sensor.setTimeout(500);
  sensor.setClickTimeout(501);
  sensor.setType(LOW_PULL);
  defaultEEPROM();
  dimming = read_string(3, 1).toInt();
  timing = read_string(3, 5);
  //Led lightening interval
  LedTime.setInterval(timing.toInt() * 1000);
}

void isr() {
  power.wakeUp();
}

void loop() {
  digitalWrite(sens_pwr, LOW);
  power.sleep(SLEEP_FOREVER);
  digitalWrite(sens_pwr, HIGH);
  isAwake = 1;
  LedTime.start();
  while (true) {
    switch (isAwake) {
      case 1: // Default Function
        default_f();
        break;
      case 2: //Menu
        menu_f();
        break;
      case 3://Dimming setting
        dimming_f();
        break;
      case 4: //Timing Function
        timing_f();
        break;
    }
  }
}
